<template>
  <div>
    <v-card
      elevation="6"
      min-width="450"
      max-height="600"
      class="overflow-y-auto"
    >
      <v-card-title>
        <v-subheader
          class="text-h5 pa-0"
          v-if="$store.state.netobject.showOnlyDefaultRules"
        >
          {{ $store.state.user.selectedNode.name }} default rules
        </v-subheader>
        <v-subheader v-else class="text-h5 pa-0"
          >Rules for {{ selectedNO.netobject }}</v-subheader
        >
        <v-spacer></v-spacer>
        <v-text-field
          style="width:30%;"
          dense
          class="text-subtitle-1"
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          single-line
          hide-details
        ></v-text-field>
      </v-card-title>
      <v-divider></v-divider>
      <v-data-table
        dense
        disable-pagination
        hide-default-footer
        no-data-text="No Rules defined for this Netobject"
        :loading="loading"
        :search="search"
        :items="rules"
        :headers="headers"
      >
        <template v-slot:[`item.updated_by`]="{ item }">
          <div class="d-inline-block" style="width: 100%">
            <div class="float-right">
              <v-tooltip v-if="item.commentary" top>
                <template v-slot:activator="{ on, attrs }">
                  <v-icon
                      v-on="on"
                      v-bind="attrs"
                      small
                  >mdi-comment-text-outline</v-icon
                  >
                </template>
                <span>{{ item.commentary }}</span>
              </v-tooltip>
            </div>
            <div style="max-width: 90px;" @click.stop class="text-truncate">
              <a
                  @click="
                userId = item.updated_by;
                showUserInfo = true;
              "
              >
                {{ item.updated_by }}
              </a>
            </div>
          </div>
        </template>
        <template v-slot:[`header.type`]="{}">
          <UserInfo
            v-if="showUserInfo"
            v-bind:id="userId"
            @user-child-object="checkUserChildObject"
          />
          <v-tooltip top>
            <template v-slot:activator="{ on, attrs }">
              <span v-bind="attrs" v-on="on">
                <v-icon small @click.prevent>mdi-sort</v-icon>
              </span>
            </template>
            <span>Initial Sorting</span>
          </v-tooltip>
        </template>
        <template v-slot:[`item.type`]="{ item }">
          <v-tooltip left>
            <template v-slot:activator="{ on, attrs }">
              <span v-bind="attrs" v-on="on"
                ><div
                  id="theme"
                  :style="
                    `height:100%; width:5px; opacity:${getOpacity(item.type)};`
                  "
                ></div
              ></span>
            </template>
            <span>{{ item.type }} Rule</span>
          </v-tooltip>
        </template>
        <template v-slot:[`item.contacts`]="{ item }">
          <span
            v-if="item.suppress"
            :class="{ 'orange--text text--darken-2': item.suppress }"
            >(Suppressed)
          </span>
          <span :class="item.suppress ? 'grey--text text-decoration-line-through' : ''">
            {{ item.contacts }}
          </span>
        </template>
        <template v-slot:[`item.actions`]="{ item }">
          <v-layout row justify-space-around px-1>
            <v-tooltip top>
              <template v-slot:activator="{ on, attrs }">
                <v-icon
                  v-on="on"
                  v-bind="attrs"
                  medium
                  v-if="
                    (item.type === 'global' &&
                      $store.getters['user/isPortalAdmin']) ||
                      item.type !== 'global'
                  "
                  @click="requestToEdit(item)"
                  >mdi-pencil</v-icon
                > </template
              ><span>Edit Rule</span>
            </v-tooltip>
            <v-icon medium disabled class="mx-1" @click.prevent
              >mdi-flip-to-front</v-icon
            >
            <v-tooltip top>
              <template v-slot:activator="{ on, attrs }">
                <v-icon
                  v-if="
                    (item.type === 'global' &&
                      $store.getters['user/isPortalAdmin']) ||
                      item.type !== 'global'
                  "
                  v-on="on"
                  v-bind="attrs"
                  medium
                  @click="requestToDelete(item)"
                  >mdi-delete</v-icon
                >
              </template>
              <span>Delete Rule</span>
            </v-tooltip>
          </v-layout>
        </template>
        <template v-slot:top>
          <div class="mx-2 my-1 caption">
            <v-icon
              id="color"
              @click.prevent="
                showGlobalRules = !showGlobalRules;
                filterRules();
              "
              >{{ showGlobalRules ? "mdi-eye" : "mdi-eye-off" }}</v-icon
            >
            Global Default Rules
            <v-icon
              class="ml-2"
              style="opacity: 0.7;"
              id="color"
              @click.prevent="
                showOrgaRules = !showOrgaRules;
                filterRules();
              "
              >{{ showOrgaRules ? "mdi-eye" : "mdi-eye-off" }}</v-icon
            >
            Organisation Default Rules
          </div>
          <v-divider></v-divider>
          <ManageRule
            v-bind:processType="processType"
            v-bind:ruleType="ruleType"
            v-bind:item="selectedItem"
            v-if="!!showManagementDialog"
            @child-object="checkChildObject"
          />
          <v-dialog v-model="showDeleteDialog" max-width="530">
            <v-card>
              <v-card-title class="headline text-break" v-if="toDeleteRule">
                Are you sure you want to delete Rule:
                {{
                  toDeleteRule.class ? "class:" + toDeleteRule.class + ", " : ""
                }}
                {{ toDeleteRule.feed ? "Feed:" + toDeleteRule.feed : "" }} ?
              </v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="blue darken-1"
                  text
                  @click="showDeleteDialog = false"
                  >close</v-btn
                >
                <v-btn color="blue darken-1" text @click="confirmDeletion"
                  >yes</v-btn
                >
              </v-card-actions>
            </v-card>
          </v-dialog>
        </template>
      </v-data-table>
    </v-card>
    <v-row justify="end">
      <v-btn
        v-if="$store.getters['user/isPortalAdmin']"
        elevation="2"
        class="my-5 mr-3"
        @click="
          processType = 'add';
          ruleType = 'global';
          resetNotification();
          showManagementDialog = true;
        "
      >
        New Global Rule
      </v-btn>
      <v-btn
        v-if="
          !showOnlyDefaultRule ||
            (showOnlyDefaultRule && $store.getters['user/isOrgaAdmin'])
        "
        elevation="2"
        class="my-5 mr-3"
        @click="
          processType = 'add';
          ruleType = 'organisation';
          resetNotification();
          showManagementDialog = true;
        "
      >
        New Organisation Rule
      </v-btn>
      <v-btn
        v-if="!showOnlyDefaultRule"
        elevation="2"
        class="my-5 mr-3"
        @click="
          processType = 'add';
          ruleType = 'netobject';
          resetNotification();
          showManagementDialog = true;
        "
      >
        New Rule
      </v-btn>
    </v-row>
    <v-text-field
      class="mt-4"
      v-if="isDeleteLoading"
      loading
      disabled
    ></v-text-field>
    <UIAlert
      class="mt-4"
      v-if="
        hasRequestError ||
          isAddSuccessful ||
          isEditSuccessful ||
          isDeleteSuccessful
      "
      v-bind:isSuccessful="!hasRequestError"
      v-bind:message="
        isAddSuccessful
          ? 'Rule added successfully'
          : isEditSuccessful
          ? 'Rule updated successfully'
          : isDeleteSuccessful
          ? 'Rule deleted successfully'
          : $store.state.application.httpErrorMessage
      "
    >
    </UIAlert>
  </div>
</template>
<style lang="scss" scoped>
::v-deep .typeColumn {
  max-width: 5px;
  width: 5px;
  padding: 0px !important;
}
::v-deep .typeColumnHeader {
  max-width: 10px;
}
::v-deep .typeColumnHeader i:last-child {
  display: none;
}
</style>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { getTitle } from "@/lib/use-fieldbuilder";
import { useHeadersBuilder } from "@/lib/use-headersbuilder";
import { mapDate } from "@/lib/use-mapper";
import { useNotification } from "@/lib/use-notification";
import { useStore } from "@/store";
import { useUserInfo } from "@/lib/use-userinfo";
import { computed, defineAsyncComponent, onMounted, ref, watch } from "vue";
import { HTTP } from "../../lib/http";

const ManageRule = defineAsyncComponent(() =>
  import("@/components/rules/ManageRule.vue")
);
const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);
const UserInfo = defineAsyncComponent(() =>
  import("@/components/usermanagement/UserInfo.vue")
);
const store = useStore();
// Table headers
const sortByInterval = (a, b) => {
  return getSeconds(a) - getSeconds(b);
};
const originalHeaders = [
  {
    text: "",
    value: "type",
    class: "typeColumnHeader pl-1 pr-2",
    cellClass: "typeColumn",
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    sort: () => {}
  },
  {
    text: "Class",
    value: "class",
    divider: true
  },
  {
    text: "Feed",
    value: "feed",
    divider: true
  },
  {
    text: "Destination",
    value: "contacts",
    divider: true
  },
  {
    text: "Interval",
    value: "interval",
    divider: true,
    hidden: !store.state.application.netobjectRules.interval.enabled,
    sort: sortByInterval
  },
  {
    text: "Last Change",
    value: "updated_at",
    divider: true
  },
  {
    text: "Action",
    value: "actions",
    sortable: false,
    width: "100px"
  }
];
const headers = ref(useHeadersBuilder(originalHeaders));
// Notifications
const {
  isAddSuccessful,
  isEditSuccessful,
  isDeleteSuccessful,
  hasRequestError,
  resetNotification
} = useNotification();
const loading = ref(false);
// Rules Requests
// Extract the necessary values for the HTTP-Requests
const selectedNO = computed(() => {
  return store.state.netobject.selectedNO;
});
const orgaID = computed(() => {
  return selectedNO.value.organisation_id;
});
const netobjectID = computed(() => {
  return selectedNO.value.type === "asn"
    ? selectedNO.value.asn_id
    : selectedNO.value.type === "network"
    ? selectedNO.value.network_id
    : selectedNO.value.type === "domain"
    ? selectedNO.value.fqdn_id
    : selectedNO.value.network_automatic_id;
});
// originalRules variable to save a copy of the Rules like they come form backend
// since we change these in an appropriate manner to be displayed in the table
const originalRules = ref();
originalRules.value = [];
const rules = ref();
const showOnlyDefaultRule = computed(() => {
  return store.state.netobject.showOnlyDefaultRules;
});
// Get organisation rules
const getOrganisationRules = () => {
  return new Promise<void>((resolve, reject) => {
    loading.value = true;
    const id = showOnlyDefaultRule.value
      ? store.state.user.selectedNode.node_id
      : orgaID.value;
    HTTP.get(`/organisations/${id}/rules`)
      .then(response => {
        originalRules.value = originalRules.value.concat(response.data);
        store.commit("netobject/setOrganisationRules", response.data);
        mapRules(response.data, rules.value);
        resolve();
      })
      .catch(() => {
        hasRequestError.value = true;
        reject();
      })
      .finally(() => {
        loading.value = false;
      });
  });
};
const getRouteForRequest = () => {
  let route = "/organisations/" + orgaID.value;
  switch (selectedNO.value.type) {
    case "asn": {
      route += "/asns/";
      break;
    }
    case "network": {
      route += "/networks/";
      break;
    }
    case "domain": {
      route += "/fqdns/";
      break;
    }
    case "networkautomatic": {
      route += `/ripe_handles/${selectedNO.value.parent}/ripe_organisations/${selectedNO.value.pivot.organisation_automatic_id}/networks/`;
      break;
    }
  }
  route += netobjectID.value + "/rules";
  return route;
};
// Get netobject rules
const getNetObjectRules = () => {
  return new Promise<void>((resolve, reject) => {
    loading.value = true;
    const route = getRouteForRequest();
    HTTP.get(route)
      .then(response => {
        originalRules.value = originalRules.value.concat(response.data);
        store.commit("netobject/setNetobjectRules", response.data);
        mapRules(response.data, rules.value);
        resolve();
      })
      .catch(() => {
        hasRequestError.value = true;
        reject();
      })
      .finally(() => {
        loading.value = false;
      });
  });
};
// Get the Global Rules
const getGlobalRules = () => {
  return new Promise<void>((resolve, reject) => {
    loading.value = true;
    HTTP.get("/global_rules")
      .then(response => {
        originalRules.value = originalRules.value.concat(response.data);
        store.commit("netobject/setGlobalRules", response.data);
        mapRules(response.data, rules.value);
        resolve();
      })
      .catch(() => {
        hasRequestError.value = true;
        reject();
      })
      .finally(() => {
        loading.value = false;
      });
  });
};
const getRules = () => {
  // Ensure executing the asynchronous functions in sequence
  // This is necessary for constructing the Rules variable
  let toDisplayRules;
  if (showOnlyDefaultRule.value) {
    if (!store.getters["user/isOrgaAdmin"]) {
      toDisplayRules = [getGlobalRules];
    } else {
      toDisplayRules = [getOrganisationRules, getGlobalRules];
    }
  } else {
    toDisplayRules = [getNetObjectRules, getOrganisationRules, getGlobalRules];
  }
  toDisplayRules.reduce(
    (pChain, currentFunction) => pChain.then(currentFunction),
    Promise.resolve()
  );
};

// Mappers
const mapRules = (data, result) => {
  data.forEach(d => {
    const rule: { [key: string]: string | number } = {};
    if (Object.keys(d).some(r => r === "asn_rule_id")) {
      rule.asn_rule_id = d.asn_rule_id;
      rule.type = "netobject";
    }
    if (Object.keys(d).some(r => r === "network_rule_id")) {
      rule.network_rule_id = d.network_rule_id;
      rule.type = "netobject";
    }
    if (Object.keys(d).some(r => r === "fqdn_rule_id")) {
      rule.fqdn_rule_id = d.fqdn_rule_id;
      rule.type = "netobject";
    }
    if (Object.keys(d).some(r => r === "network_automatic_rule_id")) {
      rule.network_automatic_rule_id = d.network_automatic_rule_id;
      rule.type = "netobject";
    }
    if (Object.keys(d).some(r => r === "organisation_rule_id")) {
      rule.organisation_rule_id = d.organisation_rule_id;
      rule.type = "organisation";
    }
    if (Object.keys(d).some(r => r === "global_rule_id")) {
      rule.global_rule_id = d.global_rule_id;
      rule.type = "global";
    }
    rule.class = [d.classification_taxonomy, d.classification_type]
      .filter(r => r)
      .map(e => e.name)
      .join("/");
    rule.feed = [d.feed_name, d.feed_provider, { name: d.feed_status }]
      .filter(r => r)
      .map(e => e.name)
      .join("/");
    rule.contacts =
      d.contacts && d.contacts.length
        ? d.contacts.map(c => getTitle(c)).join("/")
        : "";
    if (d.abuse_c) {
      rule.contacts = "Abuse-C" + (rule.contacts ? "/" + rule.contacts : "");
    }
    rule.interval = mapInterval(d.interval_length, d.interval_unit);
    rule.created_at = d.created_at ? mapDate(d.created_at) : "";
    rule.updated_at = d.updated_at ? mapDate(d.updated_at) : "";
    rule.updated_by = d.updated_by || "";
    rule.suppress = d.suppress;
    rule.abuse_c = d.abuse_c || false;
    rule.commentary = d.commentary || "";
    result.push(rule);
  });
  return result;
};
const getSeconds = (data): number => {
  if (data === "immediate") {
    return 0;
  } else {
    const length = data.substr(0, data.length - 1);
    switch (data.slice(-1)) {
      case "h": {
        return 60 * length;
      }
      case "d": {
        return 24 * 60 * length;
      }
      case "w": {
        return 7 * 24 * 60 * length;
      }
      case "m": {
        return 30 * 24 * 60 * length;
      }
      default:
        return 0;
    }
  }
};

const mapInterval = (length, unit) => {
  if (unit === "immediate") {
    return unit;
  } else {
    switch (unit) {
      case "hours": {
        return length + "h";
      }
      case "days": {
        return length + "d";
      }
      case "weeks": {
        return length + "w";
      }
      case "month": {
        return length + "m";
      }
    }
  }
};
onMounted(() => {
  refreshRules();
});

// After each Rule changes
const refreshRules = () => {
  rules.value = [];
  originalRules.value = [];
  showGlobalRules.value = true;
  showOrgaRules.value = true;
  getRules();
};

watch(
  () => selectedNO.value,
  () => {
    resetNotification();
    refreshRules();
  }
);
watch(
  () => showOnlyDefaultRule.value,
  () => {
    if (showOnlyDefaultRule.value) {
      refreshRules();
    }
  }
);
// Close rule table if node changes
watch(
  () => store.state.user.selectedNode,
  () => {
    store.commit("netobject/setshowOnlyDefaultRules", false);
    store.commit("application/setShowRules", false);
  }
);

const getOpacity = item => {
  return item === "global" ? "1" : item === "organisation" ? "0.7" : "0";
};
const showManagementDialog = ref(false);
const search = ref("");

// Show/Hide organisation/global rules
const showGlobalRules = ref(true);
const showOrgaRules = ref(true);
const filterRules = () => {
  const savedRules = [];
  mapRules(originalRules.value, savedRules);
  rules.value = savedRules;
  if (!showOrgaRules.value && !showGlobalRules.value) {
    rules.value = savedRules.filter(
      r => r["type"] !== "global" && r["type"] !== "organisation"
    );
  } else {
    if (!showOrgaRules.value) {
      rules.value = savedRules.filter(r => r["type"] !== "organisation");
    } else {
      if (!showGlobalRules.value) {
        rules.value = savedRules.filter(r => r["type"] !== "global");
      }
    }
  }
};

// Passed and emitted variables into/from the child component
const processType = ref("");
const ruleType = ref("");
const selectedItem = ref();
// Edit process
const requestToEdit = item => {
  resetNotification();
  processType.value = "edit";
  if (item.type === "netobject") {
    // Netobject Rule
    ruleType.value = "netobject";
    // Check the type of the netobject according to the *_rule_id properties
    selectedItem.value = Object.keys(item).some(r => r === "asn_rule_id")
      ? originalRules.value.filter(r => r.asn_rule_id === item.asn_rule_id)[0]
      : Object.keys(item).some(r => r === "network_rule_id")
      ? originalRules.value.filter(
          r => r.network_rule_id === item.network_rule_id
        )[0]
      : Object.keys(item).some(r => r === "fqdn_rule_id")
      ? originalRules.value.filter(r => r.fqdn_rule_id === item.fqdn_rule_id)[0]
      : originalRules.value.filter(
          r => r.network_automatic_rule_id === item.network_automatic_rule_id
        )[0];
  } else if (item.type === "organisation") {
    // Organisation Rule
    ruleType.value = "organisation";
    selectedItem.value = originalRules.value.filter(
      r => r.organisation_rule_id === item.organisation_rule_id
    )[0];
  } else {
    // Global Rule
    ruleType.value = "global";
    selectedItem.value = originalRules.value.filter(
      r => r.global_rule_id === item.global_rule_id
    )[0];
  }
  showManagementDialog.value = true;
};
// React to the emitted values
const checkChildObject = e => {
  if (e.closeDialog) {
    showManagementDialog.value = false;
  }
  if (e.ruleChanged) {
    refreshRules();
    switch (processType.value) {
      case "add": {
        isAddSuccessful.value = true;
        break;
      }
      case "edit": {
        isEditSuccessful.value = true;
      }
    }
  }
};

// Delete Rule
const showDeleteDialog = ref(false);
const toDeleteRule = ref();
const isDeleteLoading = ref(false);
const requestToDelete = item => {
  resetNotification();
  toDeleteRule.value = item;
  showDeleteDialog.value = true;
};
const confirmDeletion = () => {
  // Create the route according to the rule type
  let deleteRoute;
  if (toDeleteRule.value.type === "netobject") {
    deleteRoute =
      getRouteForRequest() +
      "/" +
      (toDeleteRule.value["asn_rule_id"] ||
        toDeleteRule.value["network_rule_id"] ||
        toDeleteRule.value["fqdn_rule_id"] ||
        toDeleteRule.value["network_automatic_rule_id"]);
  } else if (toDeleteRule.value.type === "organisation") {
    deleteRoute = `/organisations/${orgaID.value}/rules/${toDeleteRule.value.organisation_rule_id}`;
  } else {
    // Global Rule
    deleteRoute = `/global_rules/${toDeleteRule.value.global_rule_id}`;
  }
  HTTP.delete(deleteRoute)
    .then(() => {
      // Necessary to refresh the store state
      refreshRules();
      isDeleteSuccessful.value = true;
    })
    .catch(() => {
      hasRequestError.value = true;
    })
    .finally(() => {
      isDeleteLoading.value = false;
      showDeleteDialog.value = false;
    });
};

const { userId, showUserInfo, checkUserChildObject } = useUserInfo();
</script>
